Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 2231)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 2232)
@@ -20,5 +20,10 @@
 ! Current revisions:
 ! -----------------
-! 
+! - Adjustments according to new topography representation
+! - Bugfix: Move determination of nzb_max behind topography modification in 
+!   cell-edge case 
+! - Get rid off global arrays required for topography output
+! - Enable topography input via netcdf 
+! - Generic tunnel set-up added
 ! 
 ! Former revisions:
@@ -212,4 +217,7 @@
 ! ------------
 !> Creating grid depending constants
+!> To Do: Setting topo flags only based on topo_3d array - flags for former
+!> nzb_outer arrays are still not set properly. 
+!> To Do: Rearrange topo flag list
 !------------------------------------------------------------------------------!
  SUBROUTINE init_grid
@@ -230,24 +238,22 @@
                dz_stretch_level, dz_stretch_level_index, grid_level, ibc_uv_b, &
                io_blocks, io_group, inflow_l, inflow_n, inflow_r, inflow_s,    &
-               masking_method, maximum_grid_level, message_string,             &
+               lod, masking_method, maximum_grid_level, message_string,        &
                momentum_advec, nest_domain, nest_bound_l, nest_bound_n,        &
                nest_bound_r, nest_bound_s, ocean, outflow_l, outflow_n,        &
                outflow_r, outflow_s, psolver, scalar_advec, topography,        &
-               topography_grid_convention, use_surface_fluxes, use_top_fluxes, &
-               wall_adjustment_factor
+               topography_grid_convention, tunnel_height, tunnel_length,       &
+               tunnel_width_x, tunnel_width_y, tunnel_wall_depth,              &
+               use_surface_fluxes, use_top_fluxes, wall_adjustment_factor
          
     USE grid_variables,                                                        &
-        ONLY:  ddx, ddx2, ddy, ddy2, dx, dx2, dy, dy2, fwxm,                   &
-               fwxp, fwym, fwyp, fxm, fxp, fym, fyp, wall_e_x, wall_e_y,       &
-               wall_u, wall_v, wall_w_x, wall_w_y, zu_s_inner, zw_w_inner
+        ONLY:  ddx, ddx2, ddy, ddy2, dx, dx2, dy, dy2, zu_s_inner, zw_w_inner
         
     USE indices,                                                               &
-        ONLY:  flags, nbgp, nx, nxl, nxlg, nxl_mg, nxr, nxrg, nxr_mg,          &
-               ny, nyn, nyng, nyn_mg, nys, nys_mg, nysg, nz, nzb,              &
-               nzb_diff, nzb_diff_s_inner, nzb_diff_s_outer, nzb_diff_u,       &
-               nzb_diff_v, nzb_max, nzb_s_inner, nzb_s_outer, nzb_u_inner,     &
+        ONLY:  advc_flags_1, advc_flags_2, flags, nbgp, nx, nxl, nxlg, nxl_mg, &
+               nxr, nxrg, nxr_mg, ny, nyn, nyng, nyn_mg, nys, nys_mg, nysg, nz,&
+               nzb, nzb_diff, nzb_diff_s_inner, nzb_diff_s_outer,              &
+               nzb_max, nzb_s_inner, nzb_s_outer, nzb_u_inner,                 &
                nzb_u_outer, nzb_v_inner, nzb_v_outer, nzb_w_inner,             &
-               nzb_w_outer, nzt, nzt_diff, nzt_mg, rflags_invers,              &
-               rflags_s_inner, wall_flags_0, wall_flags_00, wall_flags_1,      &
+               nzb_w_outer, nzt, nzt_mg, wall_flags_0, wall_flags_1,           &
                wall_flags_10, wall_flags_2, wall_flags_3,  wall_flags_4,       &
                wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8,         &
@@ -255,6 +261,13 @@
     
     USE kinds
-    
+#if defined ( __netcdf )
+    USE netcdf_interface,                                                      &
+        ONLY:  netcdf_close_file, netcdf_open_read_file, netcdf_get_attribute, &
+               netcdf_get_variable
+#endif
     USE pegrid
+
+    USE surface_mod,                                                           &
+        ONLY:  init_bc
 
     IMPLICIT NONE
@@ -275,8 +288,10 @@
     INTEGER(iwp) ::  cys           !< index for south canyon wall
     INTEGER(iwp) ::  i             !< index variable along x
+    INTEGER(iwp) ::  id_topo       !< NetCDF id of topograhy input file
     INTEGER(iwp) ::  ii            !< loop variable for reading topography file
     INTEGER(iwp) ::  inc           !< incremental parameter for coarsening grid level
     INTEGER(iwp) ::  j             !< index variable along y
     INTEGER(iwp) ::  k             !< index variable along z
+    INTEGER(iwp) ::  k_top         !< topography top index on local PE
     INTEGER(iwp) ::  l             !< loop variable 
     INTEGER(iwp) ::  nxl_l         !< index of left PE boundary for multigrid level
@@ -286,5 +301,4 @@
     INTEGER(iwp) ::  nzb_local_max !< vertical grid index of maximum topography height
     INTEGER(iwp) ::  nzb_local_min !< vertical grid index of minimum topography height
-    INTEGER(iwp) ::  nzb_si        !< dummy index for local nzb_s_inner
     INTEGER(iwp) ::  nzt_l         !< index of top PE boundary for multigrid level
     INTEGER(iwp) ::  num_hole      !< number of holes (in topography) resolved by only one grid point 
@@ -292,28 +306,30 @@
     INTEGER(iwp) ::  num_wall      !< number of surrounding vertical walls for a single grid point
     INTEGER(iwp) ::  skip_n_rows   !< counting variable to skip rows while reading topography file    
-    INTEGER(iwp) ::  vi            !< dummy for vertical influence
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE   ::                               &
-                     vertical_influence  !< number of vertical grid points above obstacle where adjustment of near-wall mixing length is required
-                                         
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  corner_nl      !< index of north-left corner location to limit near-wall mixing length
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  corner_nr      !< north-right
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  corner_sl      !< south-left
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  corner_sr      !< south-right
+    INTEGER(iwp) ::  hv_in         !< heavyside function to model inner tunnel surface 
+    INTEGER(iwp) ::  hv_out        !< heavyside function to model outer tunnel surface 
+    INTEGER(iwp) ::  txe_out       !< end position of outer tunnel wall in x
+    INTEGER(iwp) ::  txs_out       !< start position of outer tunnel wall in x
+    INTEGER(iwp) ::  tye_out       !< end position of outer tunnel wall in y
+    INTEGER(iwp) ::  tys_out       !< start position of outer tunnel wall in y
+    INTEGER(iwp) ::  txe_in        !< end position of inner tunnel wall in x
+    INTEGER(iwp) ::  txs_in        !< start position of inner tunnel wall in x
+    INTEGER(iwp) ::  tye_in        !< end position of inner tunnel wall in y
+    INTEGER(iwp) ::  tys_in        !< start position of inner tunnel wall in y
+    INTEGER(iwp) ::  td            !< tunnel wall depth
+    INTEGER(iwp) ::  th            !< height of outer tunnel wall
+                                      
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_local      !< index for topography top at cell-center
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_tmp        !< dummy to calculate topography indices on u- and v-grid
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  wall_l         !< distance to adjacent left-facing wall
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  wall_n         !< north-facing
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  wall_r         !< right-facing
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  wall_s         !< right-facing
+
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  topo_3d !< input array for 3D topography and dummy array for setting "outer"-flags
+
+    LOGICAL  ::  netcdf_extend = .FALSE. !< Flag indicating wether netcdf topography input file or not
 
     REAL(wp) ::  dum           !< dummy variable to skip columns while reading topography file    
     REAL(wp) ::  dz_stretched  !< stretched vertical grid spacing
 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  oro_height    !< input variable for terrain height
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  topo_height   !< input variable for topography height
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zu_s_inner_l  !< dummy array on global scale to write topography output array
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_w_inner_l  !< dummy array on global scale to write topography output array
-
-    
+
 !
 !-- Calculation of horizontal array bounds including ghost layers
@@ -464,16 +480,6 @@
 !
 !-- Allocate outer and inner index arrays for topography and set
-!-- defaults.
-
-    ALLOCATE( corner_nl(nys:nyn,nxl:nxr), corner_nr(nys:nyn,nxl:nxr),       &
-              corner_sl(nys:nyn,nxl:nxr), corner_sr(nys:nyn,nxl:nxr),       &
-              wall_l(nys:nyn,nxl:nxr), wall_n(nys:nyn,nxl:nxr),             &
-              wall_r(nys:nyn,nxl:nxr), wall_s(nys:nyn,nxl:nxr) )                     
-     
-    ALLOCATE( fwxm(nysg:nyng,nxlg:nxrg), fwxp(nysg:nyng,nxlg:nxrg),         &
-              fwym(nysg:nyng,nxlg:nxrg), fwyp(nysg:nyng,nxlg:nxrg),         &
-              fxm(nysg:nyng,nxlg:nxrg), fxp(nysg:nyng,nxlg:nxrg),           &
-              fym(nysg:nyng,nxlg:nxrg), fyp(nysg:nyng,nxlg:nxrg),           &
-              nzb_s_inner(nysg:nyng,nxlg:nxrg),                             &
+!-- defaults.                    
+    ALLOCATE( nzb_s_inner(nysg:nyng,nxlg:nxrg),                             &
               nzb_s_outer(nysg:nyng,nxlg:nxrg),                             &
               nzb_u_inner(nysg:nyng,nxlg:nxrg),                             &
@@ -485,21 +491,12 @@
               nzb_diff_s_inner(nysg:nyng,nxlg:nxrg),                        &
               nzb_diff_s_outer(nysg:nyng,nxlg:nxrg),                        &
-              nzb_diff_u(nysg:nyng,nxlg:nxrg),                              &
-              nzb_diff_v(nysg:nyng,nxlg:nxrg),                              &
               nzb_local(nysg:nyng,nxlg:nxrg),                               &
               nzb_tmp(nysg:nyng,nxlg:nxrg),                                 &
-              rflags_s_inner(nzb:nzt+2,nysg:nyng,nxlg:nxrg),                &
-              rflags_invers(nysg:nyng,nxlg:nxrg,nzb:nzt+2),                 &
-              wall_e_x(nysg:nyng,nxlg:nxrg),                                &
-              wall_e_y(nysg:nyng,nxlg:nxrg),                                &
-              wall_u(nysg:nyng,nxlg:nxrg),                                  &
-              wall_v(nysg:nyng,nxlg:nxrg),                                  &
-              wall_w_x(nysg:nyng,nxlg:nxrg),                                &
-              wall_w_y(nysg:nyng,nxlg:nxrg) )
-
-
+              wall_flags_0(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+
+    ALLOCATE( topo_3d(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+    topo_3d    = 0
 
     ALLOCATE( l_wall(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-
 
     nzb_s_inner = nzb;  nzb_s_outer = nzb
@@ -507,7 +504,4 @@
     nzb_v_inner = nzb;  nzb_v_outer = nzb
     nzb_w_inner = nzb;  nzb_w_outer = nzb
-
-    rflags_s_inner = 1.0_wp
-    rflags_invers  = 1.0_wp
 
 !
@@ -519,17 +513,6 @@
        nzb_diff = nzb + 1
     ENDIF
-    IF ( use_top_fluxes )  THEN
-       nzt_diff = nzt - 1
-    ELSE
-       nzt_diff = nzt
-    ENDIF
 
     nzb_diff_s_inner = nzb_diff;  nzb_diff_s_outer = nzb_diff
-    nzb_diff_u = nzb_diff;  nzb_diff_v = nzb_diff
-
-    wall_e_x = 0.0_wp;  wall_e_y = 0.0_wp;  wall_u = 0.0_wp;  wall_v = 0.0_wp
-    wall_w_x = 0.0_wp;  wall_w_y = 0.0_wp
-    fwxp = 1.0_wp;  fwxm = 1.0_wp;  fwyp = 1.0_wp;  fwym = 1.0_wp
-    fxp  = 1.0_wp;  fxm  = 1.0_wp;  fyp  = 1.0_wp;  fym  = 1.0_wp
 
 !
@@ -542,10 +525,4 @@
     ENDDO
     l_wall(nzt+1,:,:) = l_grid(nzt)
-
-    ALLOCATE ( vertical_influence(nzb:nzt) )
-    DO  k = 1, nzt
-       vertical_influence(k) = MIN ( INT( l_grid(k) / &
-                     ( wall_adjustment_factor * dzw(k) ) + 0.5_wp ), nzt - k )
-    ENDDO
 
     DO  k = 1, nzt
@@ -561,10 +538,4 @@
        ENDIF
     ENDDO
-    vertical_influence(0) = vertical_influence(1)
-
-    DO  k = nzb + 1, nzb + vertical_influence(nzb)
-       l_wall(k,:,:) = zu(k) - zw(nzb)
-    ENDDO
-
 !
 !-- Set outer and inner index arrays for non-flat topography.
@@ -580,4 +551,10 @@
 !--       nzb_local is required for the multigrid solver
           nzb_local = 0
+!
+!--       Initialilize 3D topography array, used later for initializing flags
+          topo_3d(nzb+1:nzt+1,:,:) = IBSET( topo_3d(nzb+1:nzt+1,:,:), 0 ) 
+!
+!--       level of detail is required for output routines
+          lod       = 1
 
        CASE ( 'single_building' )
@@ -587,11 +564,6 @@
           blx = NINT( building_length_x / dx )
           bly = NINT( building_length_y / dy )
-          IF ( .NOT. ocean )  THEN
-             bh  = MINLOC( ABS( zw - building_height ), 1 ) - 1
-          ELSE
-             bh  = MINLOC( ABS( zw - zw(0) - building_height ), 1 ) - 1
-          ENDIF
-
-          IF ( ABS( zw(bh  ) - building_height ) == &
+          bh  = MINLOC( ABS( zw - building_height ), 1 ) - 1
+          IF ( ABS( zw(bh)   - building_height ) == &
                ABS( zw(bh+1) - building_height )    )  bh = bh + 1
 
@@ -626,4 +598,18 @@
 
           CALL exchange_horiz_2d_int( nzb_local, nys, nyn, nxl, nxr, nbgp )
+!
+!--       Set bit array to mask topography
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+
+                topo_3d(nzb_local(j,i)+1:nzt+1,j,i) =                          &
+                                 IBSET( topo_3d(nzb_local(j,i)+1:nzt+1,j,i), 0 ) 
+             ENDDO
+          ENDDO
+!
+!--       level of detail is required for output routines. Here, 2D topography. 
+          lod = 1
+
+          CALL exchange_horiz_int( topo_3d, nbgp )
 
        CASE ( 'single_street_canyon' )
@@ -658,11 +644,6 @@
           ENDIF
 
-          IF ( .NOT. ocean )  THEN
-             ch  = MINLOC( ABS( zw - canyon_height ), 1 ) - 1
-          ELSE
-             ch  = MINLOC( ABS( zw - zw(0) - canyon_height ), 1 ) - 1
-          ENDIF
-
-          IF ( ABS( zw(ch  ) - canyon_height ) == &
+          ch  = MINLOC( ABS( zw - canyon_height ), 1 ) - 1
+          IF ( ABS( zw(ch)   - canyon_height ) == &
                ABS( zw(ch+1) - canyon_height )    )  ch = ch + 1
 
@@ -707,8 +688,166 @@
 
           CALL exchange_horiz_2d_int( nzb_local, nys, nyn, nxl, nxr, nbgp )
+!
+!--       Set bit array to mask topography
+          DO  i = nxlg, nxrg
+             DO  j = nysg, nyng
+                topo_3d(nzb_local(j,i)+1:nzt+1,j,i) =                          &
+                                 IBSET( topo_3d(nzb_local(j,i)+1:nzt+1,j,i), 0 ) 
+             ENDDO
+          ENDDO
+!
+!--       level of detail is required for output routines. Here, 2D topography. 
+          lod = 1
+
+          CALL exchange_horiz_int( topo_3d, nbgp )
+
+       CASE ( 'tunnel' )
+
+!
+!--       Tunnel height
+          IF ( tunnel_height == 9999999.9_wp )  THEN
+             th = zw( INT( 0.2 * nz) )
+          ELSE
+             th = tunnel_height
+          ENDIF
+!
+!--       Tunnel-wall depth
+          IF ( tunnel_wall_depth == 9999999.9_wp )  THEN
+             td = MAX ( dx, dy, dz )
+          ELSE
+             td = tunnel_wall_depth
+          ENDIF
+!
+!--       Check for tunnel width
+          IF ( tunnel_width_x == 9999999.9_wp  .AND.                           &
+               tunnel_width_y == 9999999.9_wp  )  THEN
+             message_string = 'No tunnel width is given. '
+             CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( tunnel_width_x /= 9999999.9_wp  .AND.                           &
+               tunnel_width_y /= 9999999.9_wp  )  THEN
+             message_string = 'Inconsistent tunnel parameters:' //             &   
+                              'tunnel can only be oriented' //                 &
+                              'either in x- or in y-direction.'
+             CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+          ENDIF
+!
+!--       Tunnel axis along y
+          IF ( tunnel_width_x /= 9999999.9_wp )  THEN
+             IF ( tunnel_width_x > ( nx + 1 ) * dx )  THEN
+                message_string = 'Tunnel width too large'
+                CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+             ENDIF
+
+             txs_out = INT( ( nx + 1 ) * 0.5_wp * dx - tunnel_width_x * 0.5_wp )
+             txe_out = INT( ( nx + 1 ) * 0.5_wp * dx + tunnel_width_x * 0.5_wp )
+             txs_in  = INT( ( nx + 1 ) * 0.5_wp * dx -                         &
+                                      ( tunnel_width_x * 0.5_wp - td ) )
+             txe_in  = INT( ( nx + 1 ) * 0.5_wp * dx +                         &
+                                      ( tunnel_width_x * 0.5_wp - td ) )
+
+             tys_out = INT( ( ny + 1 ) * 0.5_wp * dy - tunnel_length * 0.5_wp )
+             tye_out = INT( ( ny + 1 ) * 0.5_wp * dy + tunnel_length * 0.5_wp )
+             tys_in  = tys_out
+             tye_in  = tye_out
+          ENDIF
+          IF ( tunnel_width_x /= 9999999.9_wp  .AND.                           &
+               tunnel_width_x - 2.0_wp * tunnel_wall_depth <= 2.0_wp * dx )  THEN
+             message_string = 'Tunnel width too small'
+             CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( tunnel_width_y /= 9999999.9_wp  .AND.                           &
+               tunnel_width_y - 2.0_wp * tunnel_wall_depth <= 2.0_wp * dy )  THEN
+             message_string = 'Tunnel width too small'
+             CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+          ENDIF
+!
+!--       Tunnel axis along x
+          IF ( tunnel_width_y /= 9999999.9_wp )  THEN
+             IF ( tunnel_width_y > ( ny + 1 ) * dy )  THEN
+                message_string = 'Tunnel width too large'
+                CALL message( 'init_grid', 'PA0207', 1, 2, 0, 6, 0 )
+             ENDIF
+
+             txs_out = INT( ( nx + 1 ) * 0.5_wp * dx - tunnel_length * 0.5_wp )
+             txe_out = INT( ( nx + 1 ) * 0.5_wp * dx + tunnel_length * 0.5_wp )
+             txs_in  = txs_out
+             txe_in  = txe_out
+
+             tys_out = INT( ( ny + 1 ) * 0.5_wp * dy - tunnel_width_y * 0.5_wp )
+             tye_out = INT( ( ny + 1 ) * 0.5_wp * dy + tunnel_width_y * 0.5_wp )
+             tys_in  = INT( ( ny + 1 ) * 0.5_wp * dy -                         &
+                                     ( tunnel_width_y * 0.5_wp - td ) )
+             tye_in  = INT( ( ny + 1 ) * 0.5_wp * dy +                         &
+                                     ( tunnel_width_y * 0.5_wp - td ) )
+          ENDIF
+
+          topo_3d = 0
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+!
+!--             Use heaviside function to model outer tunnel surface
+                hv_out = th * 0.5_wp *                                         &
+                              ( ( SIGN( 1.0_wp, i * dx - txs_out ) + 1.0_wp )  &
+                              - ( SIGN( 1.0_wp, i * dx - txe_out ) + 1.0_wp ) )
+
+                hv_out = hv_out * 0.5_wp *                                     &
+                            ( ( SIGN( 1.0_wp, j * dy - tys_out ) + 1.0_wp )    &
+                            - ( SIGN( 1.0_wp, j * dy - tye_out ) + 1.0_wp ) )
+! 
+!--             Use heaviside function to model inner tunnel surface
+                hv_in  = ( th - td ) * 0.5_wp *                                &
+                                ( ( SIGN( 1.0_wp, i * dx - txs_in ) + 1.0_wp ) &
+                                - ( SIGN( 1.0_wp, i * dx - txe_in ) + 1.0_wp ) )
+
+                hv_in = hv_in * 0.5_wp *                                       &
+                                ( ( SIGN( 1.0_wp, j * dy - tys_in ) + 1.0_wp ) &
+                                - ( SIGN( 1.0_wp, j * dy - tye_in ) + 1.0_wp ) )
+!
+!--             Set flags at x-y-positions without any tunnel surface
+                IF ( hv_out - hv_in == 0.0_wp )  THEN
+                   topo_3d(nzb+1:nzt+1,j,i) = IBSET( topo_3d(nzb+1:nzt+1,j,i), 0 )
+!
+!--             Set flags at x-y-positions with tunnel surfaces
+                ELSE
+                   DO  k = nzb + 1, nzt + 1
+!
+!--                   Inner tunnel
+                      IF ( hv_out - hv_in == th )  THEN
+                         IF ( zw(k) <= hv_out )  THEN
+                            topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
+                         ELSE
+                            topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 0 )
+                         ENDIF
+                      ENDIF
+!
+!--                   Lateral tunnel walls
+                      IF ( hv_out - hv_in == td )  THEN
+                         IF ( zw(k) <= hv_in )  THEN 
+                            topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 0 )
+                         ELSEIF ( zw(k) > hv_in  .AND.  zw(k) <= hv_out )  THEN 
+                            topo_3d(k,j,i) = IBCLR( topo_3d(k,j,i), 0 )
+                         ELSEIF ( zw(k) > hv_out )  THEN 
+                            topo_3d(k,j,i) = IBSET( topo_3d(k,j,i), 0 )
+                         ENDIF
+                      ENDIF
+                   ENDDO
+                ENDIF
+             ENDDO
+          ENDDO
+
+          nzb_local = 0
+!
+!--       level of detail is required for output routines. Here, 3D topography. 
+          lod = 2
+
+          CALL exchange_horiz_int( topo_3d, nbgp )
 
        CASE ( 'read_from_file' )
 
+          ALLOCATE ( oro_height(nys:nyn,nxl:nxr)  )
           ALLOCATE ( topo_height(nys:nyn,nxl:nxr) )
+          oro_height  = 0.0_wp
+          topo_height = 0.0_wp
 
           DO  ii = 0, io_blocks-1
@@ -717,35 +856,100 @@
 !
 !--             Arbitrary irregular topography data in PALM format (exactly
-!--             matching the grid size and total domain size)
-                OPEN( 90, FILE='TOPOGRAPHY_DATA'//TRIM( coupling_char ),       &
-                          STATUS='OLD', FORM='FORMATTED', ERR=10 )
-!
-!--             Read topography PE-wise. Rows are read from nyn to nys, columns
-!--             are read from nxl to nxr. At first, ny-nyn rows need to be skipped.
-                skip_n_rows = 0
-                DO WHILE ( skip_n_rows < ny - nyn )
-                   READ( 90, * )  
-                   skip_n_rows = skip_n_rows + 1
-                ENDDO
-!
-!--             Read data from nyn to nys and nxl to nxr. Therefore, skip 
-!--             column until nxl-1 is reached
-                DO  j = nyn, nys, -1
-                   READ( 90, *, ERR=11, END=11 )                               &
+!--             matching the grid size and total domain size). 
+!--             First, check if NetCDF file for topography exist or not.
+!--             This case, read topography from NetCDF, else read it from 
+!--             ASCII file.
+#if defined ( __netcdf )
+                INQUIRE( FILE='TOPOGRAPHY_DATA_NC'//TRIM( coupling_char ),     &
+                         EXIST=netcdf_extend )
+!
+!--             NetCDF branch    
+                IF ( netcdf_extend )  THEN
+!
+!--                Open file in read-only mode
+                   CALL netcdf_open_read_file( 'TOPOGRAPHY_DATA_NC',           &
+                                               id_topo, 20 )  !Error number still need to be set properly 
+
+!
+!--                Read terrain height. Reading is done PE-wise, i.e. each
+!--                processor reads its own domain. Reading is realized
+!--                via looping over x-dimension, i.e. calling 
+!--                netcdf_get_variable reads topography along y for given x. 
+!--                Orography is 2D. 
+                   DO  i = nxl, nxr
+                      CALL netcdf_get_variable( id_topo, 'orography_0',        &
+                                                i, oro_height(:,i), 20 )  !Error number still need to be set properly 
+                   ENDDO
+!
+!--                Read attribute lod (level of detail), required for variable 
+!--                buildings_0 
+                   CALL netcdf_get_attribute( id_topo, "lod", lod, .FALSE.,    &
+                                              20, 'buildings_0' ) !Error number still need to be set properly 
+!
+!--                Read building height
+!--                2D for lod = 1, 3D for lod = 2
+                   IF ( lod == 1 )  THEN
+                      DO  i = nxl, nxr
+                         CALL netcdf_get_variable( id_topo, 'buildings_0',     &
+                                                   i, topo_height(:,i), 20 )  !Error number still need to be set properly 
+                      ENDDO
+
+                   ELSEIF ( lod == 2 )  THEN
+!
+!--                   Read data PE-wise. Read yz-slices.
+                      DO  i = nxl, nxr
+                         DO  j = nys, nyn
+                            CALL netcdf_get_variable( id_topo, 'buildings_0',  &
+                                                      i, j, topo_3d(:,j,i), 20 )  !Error number still need to be set properly 
+                         ENDDO
+                      ENDDO
+                   ELSE 
+                      message_string = 'NetCDF attribute lod ' //              &
+                                       '(level of detail) is not set properly.'
+                      CALL message( 'init_grid', 'PA0208', 1, 2, 0, 6, 0 ) !Error number still need to be set properly 
+                   ENDIF
+!
+!--                Close topography input file
+                   CALL netcdf_close_file( id_topo, 20 )
+#endif
+
+!
+!--             ASCII branch. Please note, reading of 3D topography is not
+!--             supported in ASCII format. Further, no distinction is made 
+!--             between orography and buildings
+                ELSE
+
+                   OPEN( 90, FILE='TOPOGRAPHY_DATA'//TRIM( coupling_char ),    &
+                         STATUS='OLD', FORM='FORMATTED', ERR=10 )
+!
+!--                Read topography PE-wise. Rows are read from nyn to nys, columns
+!--                are read from nxl to nxr. At first, ny-nyn rows need to be skipped.
+                   skip_n_rows = 0
+                   DO WHILE ( skip_n_rows < ny - nyn )
+                      READ( 90, * )  
+                      skip_n_rows = skip_n_rows + 1
+                   ENDDO
+!
+!--                Read data from nyn to nys and nxl to nxr. Therefore, skip 
+!--                column until nxl-1 is reached
+                   DO  j = nyn, nys, -1
+                      READ( 90, *, ERR=11, END=11 )                            &
                                               ( dum, i = 0, nxl-1 ),           &
                                               ( topo_height(j,i), i = nxl, nxr )
-                ENDDO
-
-                GOTO 12
+                   ENDDO
+
+                   GOTO 12
           
- 10             message_string = 'file TOPOGRAPHY'//TRIM( coupling_char )//    &
-                                 ' does not exist'
-                CALL message( 'init_grid', 'PA0208', 1, 2, 0, 6, 0 )
-
- 11             message_string = 'errors in file TOPOGRAPHY_DATA'//            &
-                                 TRIM( coupling_char )
-                CALL message( 'init_grid', 'PA0209', 1, 2, 0, 6, 0 )
-
- 12             CLOSE( 90 )
+ 10                message_string = 'file TOPOGRAPHY'//TRIM( coupling_char )// &
+                                    ' does not exist'
+                   CALL message( 'init_grid', 'PA0208', 1, 2, 0, 6, 0 )
+
+ 11                message_string = 'errors in file TOPOGRAPHY_DATA'//         &
+                                    TRIM( coupling_char )
+                   CALL message( 'init_grid', 'PA0209', 1, 2, 0, 6, 0 )
+
+ 12                CLOSE( 90 )
+
+                ENDIF
 
              ENDIF
@@ -761,15 +965,21 @@
              DO  j = nys, nyn
                 IF ( .NOT. ocean )  THEN
-                   nzb_local(j,i) = MINLOC( ABS( zw - topo_height(j,i) ), 1 ) - 1
-                   IF ( ABS( zw(nzb_local(j,i)  ) - topo_height(j,i) ) ==      &
-                        ABS( zw(nzb_local(j,i)+1) - topo_height(j,i) )    )    &
+                   nzb_local(j,i) = MINLOC( ABS( zw - topo_height(j,i)         &
+                                                    - oro_height(j,i) ), 1 ) - 1
+                   IF ( ABS( zw(nzb_local(j,i)  ) - topo_height(j,i)           &
+                                                  - oro_height(j,i)  ) ==      &
+                        ABS( zw(nzb_local(j,i)+1) - topo_height(j,i)           &
+                                                  - oro_height(j,i)  )    )    &
                       nzb_local(j,i) = nzb_local(j,i) + 1
                 ELSE
                    nzb_local(j,i) = MINLOC( ABS( zw - zw(0)                    &
-                                                    - topo_height(j,i) ), 1 ) - 1
+                                                    - topo_height(j,i)         &
+                                                    - oro_height(j,i) ), 1 ) - 1
                    IF ( ABS( zw(nzb_local(j,i)  ) - zw(0)                      &
-                                                  - topo_height(j,i) )  ==     &
+                                                  - topo_height(j,i)           &
+                                                  - oro_height(j,i)  )  ==     &
                         ABS( zw(nzb_local(j,i)+1) - zw(0)                      &
-                                                  - topo_height(j,i) )    )    &
+                                                  - topo_height(j,i)           &
+                                                  - oro_height(j,i)  )    )    &
                       nzb_local(j,i) = nzb_local(j,i) + 1
                 ENDIF
@@ -778,4 +988,5 @@
           ENDDO
 
+          DEALLOCATE ( oro_height  )
           DEALLOCATE ( topo_height )
 !
@@ -836,10 +1047,25 @@
              CALL message( 'init_grid', 'PA0430', 0, 0, 0, 6, 0 )
           ENDIF
+
+!
+!--       Set bit array to mask topography. Only required for lod = 1
+          IF ( lod == 1 )  THEN
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   topo_3d(nzb_local(j,i)+1:nzt+1,j,i) =                          &
+                                 IBSET( topo_3d(nzb_local(j,i)+1:nzt+1,j,i), 0 ) 
+                ENDDO
+             ENDDO
+          ENDIF
 !
 !--       Exchange ghost-points, as well as add cyclic or Neumann boundary 
 !--       conditions.
+          CALL exchange_horiz_int( topo_3d, nbgp )
           CALL exchange_horiz_2d_int( nzb_local, nys, nyn, nxl, nxr, nbgp )
           
           IF ( .NOT. bc_ns_cyc )  THEN
+             IF ( nys == 0  )  topo_3d(:,-1,:)   = topo_3d(:,0,:)
+             IF ( nyn == ny )  topo_3d(:,ny+1,:) = topo_3d(:,ny,:)
+
              IF ( nys == 0  )  nzb_local(-1,:)   = nzb_local(0,:)
              IF ( nyn == ny )  nzb_local(ny+1,:) = nzb_local(ny,:)
@@ -847,7 +1073,11 @@
 
           IF ( .NOT. bc_lr_cyc )  THEN
+             IF ( nxl == 0  )  topo_3d(:,:,-1)   = topo_3d(:,:,0)
+             IF ( nxr == nx )  topo_3d(:,:,nx+1) = topo_3d(:,:,nx)     
+
              IF ( nxl == 0  )  nzb_local(:,-1)   = nzb_local(:,0)
              IF ( nxr == nx )  nzb_local(:,nx+1) = nzb_local(:,nx)          
           ENDIF
+
 
        CASE DEFAULT
